Loading...
Searching...
No Matches
AVQSVContext Struct Reference

This struct is used for communicating QSV parameters between libavcodec and the caller. More...

`#include <libavcodec/qsv.h>`

## Data Fields

mfxSession | session
| If non-NULL, the session to use for encoding or decoding.
int | iopattern
| The IO pattern to use.
mfxExtBuffer ** | ext_buffers
| Extra buffers to pass to encoder or decoder initialization.
int | nb_ext_buffers
int | opaque_alloc
| Encoding only.
int | nb_opaque_surfaces
| Encoding only, and only if opaque_alloc is set to non-zero.
AVBufferRef * | opaque_surfaces
| Encoding only, and only if opaque_alloc is set to non-zero.
int | opaque_alloc_type
| Encoding only, and only if opaque_alloc is set to non-zero.

## Detailed Description

This struct is used for communicating QSV parameters between libavcodec and the caller.

It is managed by the caller and must be assigned to AVCodecContext.hwaccel_context.

- decoding: hwaccel_context must be set on return from the get_format() callback
- encoding: hwaccel_context must be set before avcodec_open2()

Definition at line 36 of file qsv.h.

## Field Documentation

## session

mfxSession AVQSVContext::session

If non-NULL, the session to use for encoding or decoding.

Otherwise, libavcodec will try to create an internal session.

Definition at line 41 of file qsv.h.

## iopattern

int AVQSVContext::iopattern

The IO pattern to use.

Definition at line 46 of file qsv.h.

## ext_buffers

mfxExtBuffer** AVQSVContext::ext_buffers

Extra buffers to pass to encoder or decoder initialization.

Definition at line 51 of file qsv.h.

## nb_ext_buffers

int AVQSVContext::nb_ext_buffers

Definition at line 52 of file qsv.h.

## opaque_alloc

int AVQSVContext::opaque_alloc

Encoding only.

If this field is set to non-zero by the caller, libavcodec will create an mfxExtOpaqueSurfaceAlloc extended buffer and pass it to the encoder initialization. This only makes sense if iopattern is also set to MFX_IOPATTERN_IN_OPAQUE_MEMORY.

The number of allocated opaque surfaces will be the sum of the number required by the encoder and the user-provided value nb_opaque_surfaces. The array of the opaque surfaces will be exported to the caller through the opaque_surfaces field.

The caller must set this field to zero for oneVPL (MFX_VERSION >= 2.0)

Definition at line 67 of file qsv.h.

## nb_opaque_surfaces

int AVQSVContext::nb_opaque_surfaces

Encoding only, and only if opaque_alloc is set to non-zero.

Before calling avcodec_open2(), the caller should set this field to the number of extra opaque surfaces to allocate beyond what is required by the encoder.

On return from avcodec_open2(), this field will be set by libavcodec to the total number of allocated opaque surfaces.

Definition at line 78 of file qsv.h.

## opaque_surfaces

AVBufferRef* AVQSVContext::opaque_surfaces

Encoding only, and only if opaque_alloc is set to non-zero.

On return from avcodec_open2(), this field will be used by libavcodec to export the array of the allocated opaque surfaces to the caller, so they can be passed to other parts of the pipeline.

The buffer reference exported here is owned and managed by libavcodec, the callers should make their own reference with av_buffer_ref() and free it with av_buffer_unref() when it is no longer needed.

The buffer data is an nb_opaque_surfaces-sized array of mfxFrameSurface1.

Definition at line 92 of file qsv.h.

## opaque_alloc_type

int AVQSVContext::opaque_alloc_type

Encoding only, and only if opaque_alloc is set to non-zero.

On return from avcodec_open2(), this field will be set to the surface type used in the opaque allocation request.

Definition at line 99 of file qsv.h.

The documentation for this struct was generated from the following file:

- libavcodec/qsv.h